module stimulus;

   reg Clk, reset;  // Always declared so can simulate based on clock
   reg [7:0] in;
   
   wire [7:0] out;
   
   integer     handle3;
   integer     desc3;   
   
   accu accu1(in, out, Clk, reset);
   
   // Setup the clock to toggle every 1 time units 
   initial 
     begin	
	Clk = 1'b1;
	forever #5 Clk = ~Clk;
     end

   initial
     begin
	handle3 = $fopen("test.out");
	$shm_open("shm.db",1); // Opens a waveform database
	$shm_probe("AS");    // Saves all signals to database
	#200 $shm_close();   // Closes the waveform database
	#100 $finish;		
     end


   // Stimulate the Input Signals
   initial
     begin
	#0  reset<=1;
	    in<=1;
	#10 reset<=0;	    
     end

endmodule // stimulus





