`timescale 1ns/10ps
`celldefine
module AND2X1 (A, B, Y);
input  A ;
input  B ;
output Y ;

   and (Y, A, B);

   specify
     // delay parameters
     specparam
       tpllh$B$Y = 0.0652152:0.0652152:0.0652152,
       tphhl$B$Y = 0.0863419:0.0863419:0.0863419,
       tpllh$A$Y = 0.0636704:0.0636704:0.0636704,
       tphhl$A$Y = 0.0761281:0.0761281:0.0761281;

     // path delays
     (A *> Y) = (tpllh$A$Y, tphhl$A$Y);
     (B *> Y) = (tpllh$B$Y, tphhl$B$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module AND2X2 (A, B, Y);
input  A ;
input  B ;
output Y ;

   and (Y, A, B);

   specify
     // delay parameters
     specparam
       tpllh$A$Y = 0.0791513:0.0791513:0.0791513,
       tphhl$A$Y = 0.0939065:0.0939065:0.0939065,
       tpllh$B$Y = 0.0815593:0.0815593:0.0815593,
       tphhl$B$Y = 0.103564:0.103564:0.103564;

     // path delays
     (A *> Y) = (tpllh$A$Y, tphhl$A$Y);
     (B *> Y) = (tpllh$B$Y, tphhl$B$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module AOI21X1 (A, B, C, Y);
input  A ;
input  B ;
input  C ;
output Y ;

   and (I0_out, A, B);
   or  (I1_out, I0_out, C);
   not (Y, I1_out);

   specify
     // delay parameters
     specparam
       tplhl$A$Y = 0.0479146:0.0479146:0.0479146,
       tphlh$A$Y = 0.064718:0.064718:0.064718,
       tplhl$B$Y = 0.0494917:0.0494917:0.0494917,
       tphlh$B$Y = 0.0550765:0.0550765:0.0550765,
       tplhl$C$Y = 0.0389562:0.0409266:0.0428969,
       tphlh$C$Y = 0.0389953:0.0475288:0.0560623;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);
     (B *> Y) = (tphlh$B$Y, tplhl$B$Y);
     (C *> Y) = (tphlh$C$Y, tplhl$C$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module AOI22X1 (A, B, C, D, Y);
input  A ;
input  B ;
input  C ;
input  D ;
output Y ;

   and (I0_out, A, B);
   and (I1_out, C, D);
   or  (I2_out, I0_out, I1_out);
   not (Y, I2_out);

   specify
     // delay parameters
     specparam
       tplhl$C$Y = 0.0416759:0.0431164:0.0445569,
       tphlh$C$Y = 0.053915:0.0635452:0.0731754,
       tplhl$D$Y = 0.0410844:0.0427357:0.044387,
       tphlh$D$Y = 0.0465095:0.0551325:0.0637555,
       tplhl$A$Y = 0.0554709:0.0595585:0.063646,
       tphlh$A$Y = 0.0677698:0.0770328:0.0862958,
       tplhl$B$Y = 0.0564862:0.0604989:0.0645116,
       tphlh$B$Y = 0.0597927:0.069362:0.0789312;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);
     (B *> Y) = (tphlh$B$Y, tplhl$B$Y);
     (C *> Y) = (tphlh$C$Y, tplhl$C$Y);
     (D *> Y) = (tphlh$D$Y, tplhl$D$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module BUFX2 (A, Y);
input  A ;
output Y ;

   buf (Y, A);

   specify
     // delay parameters
     specparam
       tpllh$A$Y = 0.080192:0.080192:0.080192,
       tphhl$A$Y = 0.0899936:0.0899936:0.0899936;

     // path delays
     (A *> Y) = (tpllh$A$Y, tphhl$A$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module BUFX4 (A, Y);
input  A ;
output Y ;

   buf (Y, A);

   specify
     // delay parameters
     specparam
       tpllh$A$Y = 0.0944772:0.0944772:0.0944772,
       tphhl$A$Y = 0.0966568:0.0966568:0.0966568;

     // path delays
     (A *> Y) = (tpllh$A$Y, tphhl$A$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module DFFNEGX1 (CLK, D, Q);
input  CLK ;
input  D ;
output Q ;
reg NOTIFIER ;

   not (I0_CLOCK, CLK);
   udp_dff (DS0000, D, I0_CLOCK, 1'B0, 1'B0, NOTIFIER);
   not (P0002, DS0000);
   buf (Q, DS0000);

   specify
     // delay parameters
     specparam
       tphlh$CLK$Q = 0.127171:0.127171:0.127171,
       tphhl$CLK$Q = 0.12194:0.12194:0.12194,
       tsetup_posedge$D$CLK = 0.1875:0.1875:0.1875,
       tsetup_negedge$D$CLK = 0.1875:0.1875:0.1875,
       thold_posedge$D$CLK = -0.0937499:-0.0937499:-0.0937499,
       thold_negedge$D$CLK = 6.06271e-08:6.06271e-08:6.06271e-08,
       tminpwh$CLK = 0.0431835:0.0939412:0.144699,
       tminpwl$CLK = 0.0818376:0.104504:0.127171;

     // path delays
     if (CLK == 1'b0)
       (CLK *> Q) = (tphlh$CLK$Q, tphhl$CLK$Q);
     $setuphold(negedge CLK, negedge D, tsetup_negedge$D$CLK, thold_negedge$D$CLK, NOTIFIER);
     $setuphold(negedge CLK, posedge D, tsetup_posedge$D$CLK, thold_posedge$D$CLK, NOTIFIER);
     $width(posedge CLK, tminpwh$CLK, 0, NOTIFIER);
     $width(negedge CLK, tminpwl$CLK, 0, NOTIFIER);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module DFFPOSX1 (CLK, D, Q);
input  CLK ;
input  D ;
output Q ;
reg NOTIFIER ;

   udp_dff (DS0000, D, CLK, 1'B0, 1'B0, NOTIFIER);
   not (P0002, DS0000);
   buf (Q, DS0000);

   specify
     // delay parameters
     specparam
       tpllh$CLK$Q = 0.0935262:0.0935262:0.0935262,
       tplhl$CLK$Q = 0.159821:0.159821:0.159821,
       tsetup_posedge$D$CLK = 0.1875:0.1875:0.1875,
       tsetup_negedge$D$CLK = 0.1875:0.1875:0.1875,
       thold_posedge$D$CLK = 5.96047e-08:5.96047e-08:5.96047e-08,
       thold_negedge$D$CLK = -0.0937499:-0.0937499:-0.0937499,
       tminpwh$CLK = 0.0541171:0.106969:0.159821,
       tminpwl$CLK = 0.0569271:0.09927:0.141613;

     // path delays
     if (CLK == 1'b1)
       (CLK *> Q) = (tpllh$CLK$Q, tplhl$CLK$Q);
     $setuphold(posedge CLK, negedge D, tsetup_negedge$D$CLK, thold_negedge$D$CLK, NOTIFIER);
     $setuphold(posedge CLK, posedge D, tsetup_posedge$D$CLK, thold_posedge$D$CLK, NOTIFIER);
     $width(posedge CLK, tminpwh$CLK, 0, NOTIFIER);
     $width(negedge CLK, tminpwl$CLK, 0, NOTIFIER);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module FAX1 (A, B, C, YC, YS);
input  A ;
input  B ;
input  C ;
output YC ;
output YS ;

   and (I0_out, A, B);
   and (I1_out, B, C);
   or  (I2_out, I0_out, I1_out);
   and (I3_out, C, A);
   or  (YC, I2_out, I3_out);
   xor (I5_out, A, B);
   xor (YS, I5_out, C);

   specify
     // delay parameters
     specparam
       tpllh$A$YS = 0.191822:0.198183:0.204545,
       tplhl$A$YS = 0.175766:0.179906:0.184047,
       tpllh$A$YC = 0.11089:0.110961:0.111032,
       tphhl$A$YC = 0.133006:0.133895:0.134783,
       tpllh$B$YS = 0.194515:0.202117:0.209719,
       tplhl$B$YS = 0.18524:0.185393:0.185546,
       tpllh$B$YC = 0.106685:0.11476:0.122835,
       tphhl$B$YC = 0.133505:0.134739:0.135973,
       tpllh$C$YS = 0.193159:0.198886:0.204612,
       tplhl$C$YS = 0.181155:0.182744:0.184334,
       tpllh$C$YC = 0.104011:0.109702:0.115393,
       tphhl$C$YC = 0.117582:0.121862:0.126141;

     // path delays
     (A *> YC) = (tpllh$A$YC, tphhl$A$YC);
     (A *> YS) = (tpllh$A$YS, tplhl$A$YS);
     (B *> YC) = (tpllh$B$YC, tphhl$B$YC);
     (B *> YS) = (tpllh$B$YS, tplhl$B$YS);
     (C *> YC) = (tpllh$C$YC, tphhl$C$YC);
     (C *> YS) = (tpllh$C$YS, tplhl$C$YS);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module HAX1 (A, B, YC);
input  A ;
input  B ;
output YC ;

   and (YC, A, B);

   specify
     // delay parameters
     specparam
       tpllh$A$YC = 0.0853613:0.0853613:0.0853613,
       tphhl$A$YC = 0.108845:0.108845:0.108845,
       tpllh$B$YC = 0.0832261:0.0832261:0.0832261,
       tphhl$B$YC = 0.0980143:0.0980143:0.0980143;

     // path delays
     (A *> YC) = (tpllh$A$YC, tphhl$A$YC);
     (B *> YC) = (tpllh$B$YC, tphhl$B$YC);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module INVX1 (A, Y);
input  A ;
output Y ;

   not (Y, A);

   specify
     // delay parameters
     specparam
       tplhl$A$Y = 0.0309057:0.0309057:0.0309057,
       tphlh$A$Y = 0.0376394:0.0376394:0.0376394;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module INVX2 (A, Y);
input  A ;
output Y ;

   not (Y, A);

   specify
     // delay parameters
     specparam
       tplhl$A$Y = 0.032632:0.032632:0.032632,
       tphlh$A$Y = 0.0380511:0.0380511:0.0380511;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module INVX4 (A, Y);
input  A ;
output Y ;

   not (Y, A);

   specify
     // delay parameters
     specparam
       tplhl$A$Y = 0.032632:0.032632:0.032632,
       tphlh$A$Y = 0.0380511:0.0380511:0.0380511;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module INVX8 (A, Y);
input  A ;
output Y ;

   not (Y, A);

   specify
     // delay parameters
     specparam
       tplhl$A$Y = 0.032632:0.032632:0.032632,
       tphlh$A$Y = 0.0380511:0.0380511:0.0380511;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module MUX2X1 (A, B, S, Y);
input  A ;
input  B ;
input  S ;
output Y ;

   udp_mux2 (I0_out, B, A, S);
   not (Y, I0_out);

   specify
     // delay parameters
     specparam
       tpllh$S$Y = 0.100427:0.100427:0.100427,
       tplhl$S$Y = 0.0994576:0.0994576:0.0994576,
       tplhl$A$Y = 0.0498406:0.0498406:0.0498406,
       tphlh$A$Y = 0.0723509:0.0723509:0.0723509,
       tplhl$B$Y = 0.0546619:0.0546619:0.0546619,
       tphlh$B$Y = 0.0660151:0.0660151:0.0660151;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);
     (B *> Y) = (tphlh$B$Y, tplhl$B$Y);
     (S *> Y) = (tpllh$S$Y, tplhl$S$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module NAND2X1 (A, B, Y);
input  A ;
input  B ;
output Y ;

   and (I0_out, A, B);
   not (Y, I0_out);

   specify
     // delay parameters
     specparam
       tplhl$A$Y = 0.0328488:0.0328488:0.0328488,
       tphlh$A$Y = 0.0538273:0.0538273:0.0538273,
       tplhl$B$Y = 0.0307216:0.0307216:0.0307216,
       tphlh$B$Y = 0.0457927:0.0457927:0.0457927;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);
     (B *> Y) = (tphlh$B$Y, tplhl$B$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module NAND3X1 (A, B, C, Y);
input  A ;
input  B ;
input  C ;
output Y ;

   and (I0_out, A, B);
   and (I1_out, I0_out, C);
   not (Y, I1_out);

   specify
     // delay parameters
     specparam
       tplhl$B$Y = 0.0388225:0.0388225:0.0388225,
       tphlh$B$Y = 0.0661183:0.0661183:0.0661183,
       tplhl$A$Y = 0.0411603:0.0411603:0.0411603,
       tphlh$A$Y = 0.0769998:0.0769998:0.0769998,
       tplhl$C$Y = 0.0326033:0.0326033:0.0326033,
       tphlh$C$Y = 0.0515211:0.0515211:0.0515211;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);
     (B *> Y) = (tphlh$B$Y, tplhl$B$Y);
     (C *> Y) = (tphlh$C$Y, tplhl$C$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module NOR2X1 (A, B, Y);
input  A ;
input  B ;
output Y ;

   or  (I0_out, A, B);
   not (Y, I0_out);

   specify
     // delay parameters
     specparam
       tplhl$B$Y = 0.0384013:0.0384013:0.0384013,
       tphlh$B$Y = 0.0440514:0.0440514:0.0440514,
       tplhl$A$Y = 0.0520235:0.0520235:0.0520235,
       tphlh$A$Y = 0.0487569:0.0487569:0.0487569;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);
     (B *> Y) = (tphlh$B$Y, tplhl$B$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module NOR3X1 (A, B, C, Y);
input  A ;
input  B ;
input  C ;
output Y ;

   or  (I0_out, A, B);
   or  (I1_out, I0_out, C);
   not (Y, I1_out);

   specify
     // delay parameters
     specparam
       tplhl$B$Y = 0.0688493:0.0688493:0.0688493,
       tphlh$B$Y = 0.0646551:0.0646551:0.0646551,
       tplhl$C$Y = 0.0492526:0.0492526:0.0492526,
       tphlh$C$Y = 0.0480378:0.0480378:0.0480378,
       tplhl$A$Y = 0.0768709:0.0768709:0.0768709,
       tphlh$A$Y = 0.0699091:0.0699091:0.0699091;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);
     (B *> Y) = (tphlh$B$Y, tplhl$B$Y);
     (C *> Y) = (tphlh$C$Y, tplhl$C$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module OAI21X1 (A, B, C, Y);
input  A ;
input  B ;
input  C ;
output Y ;

   or  (I0_out, A, B);
   and (I1_out, I0_out, C);
   not (Y, I1_out);

   specify
     // delay parameters
     specparam
       tplhl$A$Y = 0.0503249:0.0503249:0.0503249,
       tphlh$A$Y = 0.0663602:0.0663602:0.0663602,
       tplhl$B$Y = 0.0403731:0.0403731:0.0403731,
       tphlh$B$Y = 0.0613772:0.0613772:0.0613772,
       tplhl$C$Y = 0.0296272:0.0376244:0.0456215,
       tphlh$C$Y = 0.0478173:0.0486617:0.0495062;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);
     (B *> Y) = (tphlh$B$Y, tplhl$B$Y);
     (C *> Y) = (tphlh$C$Y, tplhl$C$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module OAI22X1 (A, B, C, D, Y);
input  A ;
input  B ;
input  C ;
input  D ;
output Y ;

   or  (I0_out, A, B);
   or  (I1_out, C, D);
   and (I2_out, I0_out, I1_out);
   not (Y, I2_out);

   specify
     // delay parameters
     specparam
       tplhl$D$Y = 0.0382209:0.04673:0.055239,
       tphlh$D$Y = 0.0547484:0.0554435:0.0561387,
       tplhl$C$Y = 0.0443571:0.0539796:0.063602,
       tphlh$C$Y = 0.0588171:0.0594492:0.0600812,
       tplhl$A$Y = 0.0508171:0.0601595:0.0695019,
       tphlh$A$Y = 0.0747552:0.0777333:0.0807115,
       tplhl$B$Y = 0.0440493:0.0515101:0.0589709,
       tphlh$B$Y = 0.0705001:0.0732466:0.075993;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);
     (B *> Y) = (tphlh$B$Y, tplhl$B$Y);
     (C *> Y) = (tphlh$C$Y, tplhl$C$Y);
     (D *> Y) = (tphlh$D$Y, tplhl$D$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module OR2X1 (A, B, Y);
input  A ;
input  B ;
output Y ;

   or  (Y, A, B);

   specify
     // delay parameters
     specparam
       tpllh$B$Y = 0.0862337:0.0862337:0.0862337,
       tphhl$B$Y = 0.0805478:0.0805478:0.0805478,
       tpllh$A$Y = 0.0740876:0.0740876:0.0740876,
       tphhl$A$Y = 0.0760981:0.0760981:0.0760981;

     // path delays
     (A *> Y) = (tpllh$A$Y, tphhl$A$Y);
     (B *> Y) = (tpllh$B$Y, tphhl$B$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module OR2X2 (A, B, Y);
input  A ;
input  B ;
output Y ;

   or  (Y, A, B);

   specify
     // delay parameters
     specparam
       tpllh$B$Y = 0.100325:0.100325:0.100325,
       tphhl$B$Y = 0.0991908:0.0991908:0.0991908,
       tpllh$A$Y = 0.0927483:0.0927483:0.0927483,
       tphhl$A$Y = 0.0943953:0.0943953:0.0943953;

     // path delays
     (A *> Y) = (tpllh$A$Y, tphhl$A$Y);
     (B *> Y) = (tpllh$B$Y, tphhl$B$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module TBUFX1 (A, EN, Y);
input  A ;
input  EN ;
output Y ;

   not (I0_out, A);
   bufif1 (Y, I0_out, EN);

   specify
     // delay parameters
     specparam
       tpzh$EN$Y = 0.0643139:0.0643139:0.0643139,
       tpzl$EN$Y = 0.0210639:0.0210639:0.0210639,
       tplz$EN$Y = 0.0444167:0.0444167:0.0444167,
       tphz$EN$Y = 0.0589076:0.0589076:0.0589076,
       tplhl$A$Y = 0.0431759:0.0431759:0.0431759,
       tphlh$A$Y = 0.0622706:0.0622706:0.0622706;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);
     (EN *> Y) = (0, 0, tplz$EN$Y, tpzh$EN$Y, tphz$EN$Y, tpzl$EN$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module TBUFX2 (A, EN, Y);
input  A ;
input  EN ;
output Y ;

   not (I0_out, A);
   bufif1 (Y, I0_out, EN);

   specify
     // delay parameters
     specparam
       tplhl$A$Y = 0.04457:0.04457:0.04457,
       tphlh$A$Y = 0.0624696:0.0624696:0.0624696,
       tpzh$EN$Y = 0.0665881:0.0665881:0.0665881,
       tpzl$EN$Y = 0.0213535:0.0213535:0.0213535,
       tplz$EN$Y = 0.0444167:0.0444167:0.0444167,
       tphz$EN$Y = 0.0597342:0.0597342:0.0597342;

     // path delays
     (A *> Y) = (tphlh$A$Y, tplhl$A$Y);
     (EN *> Y) = (0, 0, tplz$EN$Y, tpzh$EN$Y, tphz$EN$Y, tpzl$EN$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module XNOR2X1 (A, B, Y);
input  A ;
input  B ;
output Y ;

   xor (I0_out, A, B);
   not (Y, I0_out);

   specify
     // delay parameters
     specparam
       tpllh$A$Y = 0.0845444:0.0845444:0.0845444,
       tplhl$A$Y = 0.0805984:0.0805984:0.0805984,
       tpllh$B$Y = 0.10043:0.10043:0.10043,
       tplhl$B$Y = 0.0888509:0.0888509:0.0888509;

     // path delays
     (A *> Y) = (tpllh$A$Y, tplhl$A$Y);
     (B *> Y) = (tpllh$B$Y, tplhl$B$Y);

   endspecify

endmodule
`endcelldefine

`timescale 1ns/10ps
`celldefine
module XOR2X1 (A, B, Y);
input  A ;
input  B ;
output Y ;

   xor (Y, A, B);

   specify
     // delay parameters
     specparam
       tpllh$B$Y = 0.0958559:0.0958559:0.0958559,
       tplhl$B$Y = 0.0908635:0.0908635:0.0908635,
       tpllh$A$Y = 0.0846684:0.0846684:0.0846684,
       tplhl$A$Y = 0.0802167:0.0802167:0.0802167;

     // path delays
     (A *> Y) = (tpllh$A$Y, tplhl$A$Y);
     (B *> Y) = (tpllh$B$Y, tplhl$B$Y);

   endspecify

endmodule
`endcelldefine

primitive udp_dff (out, in, clk, clr, set, NOTIFIER);
   output out;
   input  in, clk, clr, set, NOTIFIER;
   reg    out;

   table

// in  clk  clr   set  NOT  : Qt : Qt+1
//
   0  r   ?   0   ?   : ?  :  0  ; // clock in 0
   1  r   0   ?   ?   : ?  :  1  ; // clock in 1
   1  *   0   ?   ?   : 1  :  1  ; // reduce pessimism
   0  *   ?   0   ?   : 0  :  0  ; // reduce pessimism
   ?  f   ?   ?   ?   : ?  :  -  ; // no changes on negedge clk
   *  b   ?   ?   ?   : ?  :  -  ; // no changes when in switches
   ?  ?   ?   1   ?   : ?  :  1  ; // set output
   ?  b   0   *   ?   : 1  :  1  ; // cover all transistions on set
   1  x   0   *   ?   : 1  :  1  ; // cover all transistions on set
   ?  ?   1   0   ?   : ?  :  0  ; // reset output
   ?  b   *   0   ?   : 0  :  0  ; // cover all transistions on clr
   0  x   *   0   ?   : 0  :  0  ; // cover all transistions on clr
   ?  ?   ?   ?   *   : ?  :  x  ; // any notifier changed

   endtable
endprimitive // udp_dff

primitive udp_tlat (out, in, enable, clr, set, NOTIFIER);

   output out;
   input  in, enable, clr, set, NOTIFIER;
   reg    out;

   table

// in  enable  clr   set  NOT  : Qt : Qt+1
//
   1  1   0   ?   ?   : ?  :  1  ; //
   0  1   ?   0   ?   : ?  :  0  ; //
   1  *   0   ?   ?   : 1  :  1  ; // reduce pessimism
   0  *   ?   0   ?   : 0  :  0  ; // reduce pessimism
   *  0   ?   ?   ?   : ?  :  -  ; // no changes when in switches
   ?  ?   ?   1   ?   : ?  :  1  ; // set output
   ?  0   0   *   ?   : 1  :  1  ; // cover all transistions on set
   1  ?   0   *   ?   : 1  :  1  ; // cover all transistions on set
   ?  ?   1   0   ?   : ?  :  0  ; // reset output
   ?  0   *   0   ?   : 0  :  0  ; // cover all transistions on clr
   0  ?   *   0   ?   : 0  :  0  ; // cover all transistions on clr
   ?  ?   ?   ?   *   : ?  :  x  ; // any notifier changed

   endtable
endprimitive // udp_tlat

primitive udp_rslat (out, clr, set, NOTIFIER);

   output out;
   input  clr, set, NOTIFIER;
   reg    out;

   table

// clr   set  NOT  : Qt : Qt+1
//
   ?   1   ?   : ?  :  1  ; // set output
   0   *   ?   : 1  :  1  ; // cover all transistions on set
   1   0   ?   : ?  :  0  ; // reset output
   *   0   ?   : 0  :  0  ; // cover all transistions on clr
   ?   ?   *   : ?  :  x  ; // any notifier changed

   endtable
endprimitive // udp_tlat

primitive udp_mux2 (out, in0, in1, sel);
   output out;
   input  in0, in1, sel;

   table

// sel in0 in1 :  out
//
    1  ?  0 :  1 ;
    0  ?  0 :  0 ;
    ?  1  1 :  1 ;
    ?  0  1 :  0 ;
    0  0  x :  0 ;
    1  1  x :  1 ;

   endtable
endprimitive // udp_mux2

